;+---------------------------------------------------------------------------+
;|                                                                           |
;|                                                            |
;|                                                                           |
;+---------------------------------------------------------------------------+
VARIABLE RND.SEED

$COLN RANDOMIZE
      _         TIMER-READ RND.SEED ! EXIT

$COLN RANDOM  ; ( nmax -- nrandom )
      _         RND.SEED @ 4E6Dh * 12345 + 07FFFh AND DUP RND.SEED ! SWAP MOD EXIT




VARIABLE TMR$MULT,,1193         ; 樥 ᪮ ࠡ ⠩

;
; 樠 ⠩
;
$COLN TIMER-INIT
      _         2386 TMR$MULT !         ;; TMR$MULT = 1193*2
      _         100 0 DO
      _             TIMER-READ 1 AND 0=
      _             IF
      _                  1193 TMR$MULT !
      _                  LEAVE
      _             THEN
      _         LOOP
      _         EXIT


;
; ࣠   msec ᥪ㭤  ᯮ짮 ⥬ ⠩
;
$CODE DELAY ; ( msec -- )       㧠  msec ᥪ㭤
        call    get_timer
        mov     cx, ax          ; cx - prev
        pop     ax              ; ax - msec
        mov     bx, [$$_TMR$MULT]
        mul     bx              ; dx:ax - (milliseconds * multiplier)
        add     ax, cx
        adc     dx, 0
        mov     bx, ax          ; dx:bx - stop
        ; while ((cur = readtimer()) < stop)
    @while_del:
        call    get_timer
        mov     di, ax          ; di    - cur
        ; cur < stop ?
        or      dx, dx
        jnz     @do_loop        ; -> (stop > cur)
        cmp     di, bx
        ja      @quit_del       ; -> 室 (cur > stop)
    @do_loop:
        cmp     di, cx          ; Check for timer wraparound
        jae     @next_del
        ; cur < prev
        or      dx, dx
        jz      @quit_del       ; -> (stop < 0x10000)
        dec     dx              ; stop -= 0x10000
    @next_del:
        mov     cx, di
        jmp     @while_del
    @quit_del:
        $NEXT


;
; ⥭  ⥬ ⠩
;
$CODE TIMER-READ ; ( -- u )
        call    get_timer
        push    ax
        $NEXT


proc get_timer nolanguage
        push    bx cx dx si di
        cli                     ; Disable interrupts
        mov     al, 0h          ; Latch timer 0
        out     43h, al         ;
        call    @@dummy         ; Waste some time
        in      al, 40h         ; Counter --> bx
        mov     bl, al          ; LSB in BL
        call    @@dummy         ; Waste some time
        in      al, 40h         ;
        mov     bh, al          ; MSB in BH
        not     bx              ; Need ascending counter
        mov     ax, bx          ; return in AX
        sti
        pop     di si dx cx bx
        ret
  @@dummy:
        nop
        nop
        nop
        retn
endp

