include "system.inc"


; ࠧ "⠪"
PIT_WIDTH       equ 10          ; ਭ  "ᥫ"
PIT_CWIDTH      equ 20          ; ਭ  ᨬ
PIT_HEIGHT      equ 20          ;   ᨬ


CONSTANT KEY.LEFT, 'J'
CONSTANT KEY.ROT, 'K'
CONSTANT KEY.RIGHT, 'L'
CONSTANT KEY.DROP, ' '
CONSTANT KEY.PAUSE, 'P'
CONSTANT KEY.NEW, 'N'
CONSTANT KEY.QUIT, 'Q'
VARIABLE GAME.CONTINUE,,1

CONSTANT KEY.COLOR, 0Dh                 ; 梥   ᪠
CONSTANT KEY.TXTCOL, 0Eh                ; 梥 ᪠  
CONSTANT SCORE.COLOR, 0Ah               ; 梥 ᨬ 窮 ப
CONSTANT STATUS.COLOR, 0Bh              ; 梥 ᨬ ப 
CONSTANT HELP.COLOR, 0Fh                ; 梥 ᪠

VARIABLE GAME.SCORE                     ; 窨
VARIABLE GAME.PIECES                    ; ⢮ 㫮 䨣
VARIABLE GAME.LEVELS                    ; ஢
VARIABLE GAME.SPEED                     ; ᪮

;-----------------------------------------------------------------------------
; ⠪
;-----------------------------------------------------------------------------
CONSTANT PIT.X, 2                       ;  "⠪"  ࠭
CONSTANT PIT.Y, 1                       ; (砫 न)
CONSTANT PIT.WIDTH, PIT_WIDTH           ; ࠧ ⠪  "ᥫ"
CONSTANT PIT.HEIGHT, PIT_HEIGHT
CONSTANT PIT.CWIDTH, PIT_CWIDTH         ; ࠧ ⠪  ᨬ

VARIABLE PIT.DATA, <PIT_CWIDTH*2*PIT_HEIGHT> ; ⠪

CONSTANT PIT.COLOR, 71h                 ; 梥  ⠪
CONSTANT PIT.BACKGR, 0020h              ; 梥  䮭 ⠪
CONSTANT PIT.BORDER, ''

;-----------------------------------------------------------------------------
; 
;-----------------------------------------------------------------------------
VARIABLE BRICK.X                        ; न 䨣  ⠪ (⭮⥫)
VARIABLE BRICK.Y

VARIABLE BRICK.DATA, 32                 ; ࠧ ⥪饩 䨣
VARIABLE BRICK.TMP, 32                  ; ६ﭪ  ⮢ 䨣
VARIABLE BRICK.NEXT                     ; ᫥ 䨣

; ࠧ 䨣  ଠ - ᨬ  ਡ⮬ 梥
VARIABLE BRICK1, 32
VARIABLE BRICK2, 32
VARIABLE BRICK3, 32
VARIABLE BRICK4, 32
VARIABLE BRICK5, 32
VARIABLE BRICK6, 32
VARIABLE BRICK7, 32

; 梥 䨣

BRICKCOL1 = (1 shl 4) or 15
BRICKCOL2 = (2 shl 4) or 13
BRICKCOL3 = (3 shl 4) or 12
BRICKCOL4 = (4 shl 4) or 10
BRICKCOL5 = (5 shl 4) or 14
BRICKCOL6 = (6 shl 4) or 11
BRICKCOL7 = (7 shl 4) or 9


; ⠫ 䨣 4x4 祩  ᨬ쭮 ଠ
STRING SBRICK1, BRICKCOL1, "        ()()()()                "
STRING SBRICK2, BRICKCOL2, "        ######    ##            "
STRING SBRICK3, BRICKCOL3, "          {}{}{}  {}            "
STRING SBRICK4, BRICKCOL4, "        <><><>      <>          "
STRING SBRICK5, BRICKCOL5, "          [][]    [][]          "
STRING SBRICK6, BRICKCOL6, "        @@@@      @@@@          "
STRING SBRICK7, BRICKCOL7, "          %%%%  %%%%            "

; 塞    䨣 窨
VARIABLE BRICK.SCORE,,<1,2,3,3,4,5,5>




; /⥭ "ᥫ" (2 ᬥ ᨬ  ਡ⠬ (4 ))

$COLN 2C@ ; (addr -- ch cl)
      _         DUP CELL+ C@ SWAP C@ EXIT

$COLN 2W@ ; (addr -- wh wl)
      _         DUP CELL+ @ SWAP @ EXIT

$COLN 2W! ; (wh wl addr -- )
      _         DUP CELL+ >R ! R> ! EXIT

$COLN D<>
      _         DNEG D+ D0= NOT EXIT



; ----
; ⠢  ⥪ ᨬ ⮩ 祩 ⠪
;
$COLN EMPTY-CELL
      _         ' ' DUP EXIT

; ----
; ᮢ  㤠  祩 ⠪  䨣
;
$COLN DRAW-CELL ; ( c1 c2 --- ) ; c1  c2 - ᫮: ᨬ+ਡ
      _         EMIT EMIT EXIT




;----------------------------------------------------------------------------+
;                                                                            |
;                                                                       |
;                                                                            |
;----------------------------------------------------------------------------+

; ----
; ⠭ ਡ 梥 뢮  ࠭ ᨬ
;
$COLN !ATR ; ( c -- )
      _         ATR ! EXIT

; ----
;   ࠭   
;
$CODE VID-IMAGE ; ( img w h x y -- )
        ; 塞  
        pop     bx              ; bx - y
        pop     di              ; di - x
        xor     ax, ax
        mov     es, ax          ; ds - ᥣ  BIOS
        mov     ax, [es:44Ah]
        xchg    ax, bx          ; bx - ਭ ࠭  ᨬ
        mul     bx              ; ax = width*y
        mov     dx, 3D4h        ; ।塞 ᥣ 
        add     di, ax          ; Vidseg = B800h - ((3D4h-crt_base) shl 6)
        sub     dx, [es:463h]
        mov     ax, 0B800h      ; ।   稨 梥⭮ 
        shl     dx, 6           ; ᫨ ஬,  dx = 800h
        shl     di, 1           ; 뢠  ਡ⮢
        sub     ax, dx
        add     di, [es:44Eh]   ; 塞 ᬥ饭 ⨢ ࠭
        mov     es, ax          ; es:di - vid ptr
        ; ⠢ ஢
        pop     ax              ; ax - height image
        pop     dx              ; dx - width image
        sub     bx, dx
        shl     bx, 1           ; bx - screen increment
        pop     cx
        push    si
        mov     si, cx          ; si - image
        ; 㥬
    @@vloop:
        mov     cx, dx
        rep     movsw
        add     di, bx
        dec     ax
        jnz     @@vloop
        ; 室
        pop     si
        $NEXT

; ----
;  砫 ⨪쭮 ஢ ࠭
;
$CODE V-SYNC
        mov     dx,3dah         ;     VGA
        ; 믮塞 p  p㦥 p ⮡p
    @@wait_display_disable:
        in      al,dx
        test    al,01
        jnz     @@wait_display_disable
        ; 믮塞 p  p㦥 p p⨪쭮 ppp
        mov     dx,3dah         ;     VGA
    @@wait_vsync:
        in      al,dx
        test    al,08
        jz      @@wait_vsync
        $NEXT

; ----
; ६饭   ࠭
;
$CODE GOTO-XY ; ( x y -- )
        pop     ax
        pop     dx              ; dl - x
        mov     dh, al          ; dh - y
        push    si bp
        mov     ah, 2
        xor     bx, bx
        int     10h
        pop     bp si
        $NEXT

; ----
; ⪠ ࠭
;
$CODE CLRSCR
        push    bp si
        mov     bh, 07h         ; ਡ ⥫ ⮩ ப
        xor     cx, cx          ;  孨 㣮
        mov     dl, 79          ;  ⮫ ࠢ  㣫 
        mov     dh, 24          ;  ப ࠢ  㣫 
        mov     ah, 6
        mov     al, 0
        int     10h
        pop     si bp
        $NEXT


;----------------------------------------------------------------------------+
;                                                                            |
;                               樠                            |
;                                                                            |
;----------------------------------------------------------------------------+

$CODE VID-INIT
        mov     ax, 3
        int     10h
        $NEXT

; ----
;  ⥪⮢ ப  䨣ࠬ  ப  ਡ⠬ 梥
;
$COLN CONV-BRICK ; ( dst src -- )
      _         COUNT 1- SWAP COUNT 8 SHL >R
      _         BEGIN
      _             OVER >0
      _         WHILE
      _             ROT SWAP 2DUP C@ DUP ' ' =
      _             IF
      _                 700h
      _             ELSE
      _                 R@
      _             THEN
      _             OR SWAP ! 1+ ROT 1- ROT CELL+ SWAP ROT
      _         REPEAT
      _         R> 2DROP 2DROP
      _         EXIT



; ----
; ᮧ 梥 ࠧ 䨣  ⥪⮢
;
$COLN INIT-BRICKS
      _         BRICK1 SBRICK1 CONV-BRICK
      _         BRICK2 SBRICK2 CONV-BRICK
      _         BRICK3 SBRICK3 CONV-BRICK
      _         BRICK4 SBRICK4 CONV-BRICK
      _         BRICK5 SBRICK5 CONV-BRICK
      _         BRICK6 SBRICK6 CONV-BRICK
      _         BRICK7 SBRICK7 CONV-BRICK
      _         EXIT


; ----
; 樠 
;
$COLN INIT-GAME ; ( -- )
      _         0 GAME.SCORE !  0 GAME.PIECES !
      _         0 GAME.LEVELS !  100 GAME.SPEED !
      _         PIT-CLEAR TIMER-INIT RANDOMIZE
      _         7 RANDOM BRICK.NEXT !
      _         VID-INIT CLRSCR PIT-FRAME PIT-DRAW SHOW-HELP SHOW-SCORES EXIT



;----------------------------------------------------------------------------+
;                                                                            |
;                           뢮 ᪠  㫠                         |
;                                                                            |
;----------------------------------------------------------------------------+

CONSTANT HELP.X, 40
CONSTANT HELP.Y, 16

STRING help01, ">>> T E T R I S <<<"
STRING help02, "___________________"
STRING help03, "Use keys:"
STRING help04, "Move left"
STRING help05, "Move right"
STRING help06, "Rotate"
STRING help07, "Drop"
STRING help08, "Pause"
STRING help09, "New game"
STRING help10, "Quit"
STRING help11, "->"
STRING help12, "Score:"
STRING help13, "Pieces:"
STRING help14, "Level:"


STRING sAnyKey, "Press any key"
STRING sNew, "New game?"
STRING sQuit, "Quit?"
STRING sPause, "Paused"
STRING sEmpty, "             "

; ----
; 뢮 ப  ⥪饬 ﭨ 
;
$COLN STATUS-STR ; ( addr-str -- )
      _         STATUS.COLOR !ATR HELP.X HELP.Y GOTO-XY PUT-STR EXIT

; ----
; ⪠ ப ﭨ
;
$COLN STATUS-CLR
      _         sEmpty STATUS-STR EXIT

; ----
; 뢮  ࠭ ᨬ 
;
$COLN SHOW-KEY ; ( x y str addr-key -- )
      _         >R >R 2DUP GOTO-XY R> R>
      _         KEY.COLOR !ATR
      _         '`' DRAW-CELL 27h EMIT SPACE
      _         KEY.TXTCOL !ATR
      _         PUT-STR
      _         1+
      _         EXIT

; ----
; 뢮 ப  ⥪ 
;
$COLN PUT-STR ; ( str -- )
      _         COUNT TYPE CR EXIT


$COLN HELP-STR ; ( x y str -- x (y+1) )
      _         >R 2DUP GOTO-XY R> PUT-STR 1+ EXIT


; ----
; 뢮 ࠢ  ࠭
;
$COLN SHOW-HELP ; ( -- )
      _         HELP.COLOR !ATR
      _         HELP.X 3 - 1
      _         help01 HELP-STR
      _         help02 HELP-STR
      _         3 +
      _         help03 HELP-STR
      _         SWAP CELL+ SWAP
      _         1+
      _         help04 KEY.LEFT    SHOW-KEY
      _         help05 KEY.RIGHT   SHOW-KEY
      _         help06 KEY.ROT     SHOW-KEY
      _         help07 KEY.DROP    SHOW-KEY
      _         help08 KEY.PAUSE   SHOW-KEY
      _         help09 KEY.NEW     SHOW-KEY
      _         help10 KEY.QUIT    SHOW-KEY
      _         STATUS.COLOR !ATR
      _         SWAP 2 - SWAP
      _         1+
      _         help11 HELP-STR
      _         2 +
      _         help12 HELP-STR
      _         help13 HELP-STR
      _         help14 HELP-STR
      _         2DROP EXIT


; ---
; 뢮  ࠭ ﭨ  - 窨, . 㫮 䨣  ⠤
;
$COLN SHOW-SCORES ; ( -- )
      _         ATR @ SCORE.COLOR !ATR
      _         HELP.X 5 + HELP.Y 3 +
      _         2DUP GOTO-XY GAME.SCORE @ 6 .R
      _         1+ 2DUP GOTO-XY GAME.PIECES @ 6 .R
      _         1+ GOTO-XY GAME.LEVELS @ 6 .R
      _         !ATR
      _         EXIT


;----------------------------------------------------------------------------+
;                                                                            |
;                                                                            |
;                                                                            |
;----------------------------------------------------------------------------+


; ----
; 樮   ࠭ ⭮⥫쭮 PIT.X  PIT.Y
;
$COLN PIT-XY ; ( y x --- )
      _         2* PIT.X + SWAP PIT.Y + GOTO-XY EXIT


; ----
; 頥   ⠪   न⠬
;
$COLN PIT-ADR ; ; ( y x -- &PIT.DATA[((y*10)+x)*2]
      _         PIT.DATA ROT PIT.WIDTH * ROT + 2 SHL + EXIT


; ----
; ⪠ ⠪
;
$COLN PIT-CLEAR ; ( -- )
      _         PIT.DATA
      _         PIT.CWIDTH PIT.HEIGHT *
      _         0 DO PIT.BACKGR OVER ! CELL+ LOOP
      _         EXIT


; ----
; ᮢ ⮫쪮 誠 ⠪
;
$COLN PIT-BOTTOM ; ( -- )
      _         PIT.COLOR !ATR
      _         PIT.HEIGHT -1 PIT-XY
      _         PIT.BORDER 1+ DUP DRAW-CELL
      _         PIT.WIDTH 0 DO  PIT.BORDER DUP DRAW-CELL  LOOP
      _         PIT.BORDER 1+ DUP DRAW-CELL EXIT

; ----
; ᮢ ⥭ ⠪
;
$COLN PIT-FRAME ; ( -- )
      _         PIT.COLOR !ATR
      _         PIT.HEIGHT 0 DO
      _             I -1 PIT-XY PIT.BORDER DUP DRAW-CELL
      _             I PIT.WIDTH PIT-XY PIT.BORDER DUP DRAW-CELL
      _         LOOP
      _         PIT-BOTTOM
      _         EXIT

$COLN PIT-CLRLIN ; ( line -- )
      _         0 PIT-ADR
      _         PIT.CWIDTH 0 DO
      _             PIT.BACKGR OVER ! CELL+
      _         LOOP
      _         DROP EXIT


; ----
; ७ ᮤন ⠪  ࠭
;
$COLN PIT-DRAW  ; ( --)
      _         PIT.DATA PIT.CWIDTH PIT.HEIGHT PIT.X PIT.Y VID-IMAGE EXIT

; ----
; 뢮  ࠭ ᫥饩 䨣
$COLN NEXT-DRAW
      _         BRICK.NEXT @ BRICKS
      _         8 4
      _         PIT.X PIT.CWIDTH + 4 + PIT.Y
      _         VID-IMAGE
      _         EXIT


; ----
; 頥 㪠⥫   ᨢ 䨣
;
$COLN ADR-BRICK ; ( y x addr -- addr )
      _         ROT 4 * ROT + 2 SHL + EXIT

; ----
; 頥 㪠⥫   ᨢ ⥪饩 䨣 (BRICK.DATA)
;
$COLN CUR-BRICK ; ( y x -- addr )
      _         BRICK.DATA ADR-BRICK EXIT

; ----
; 頥 㪠⥫   ᨢ ६ 䨣 (BRICK.TMP)
;
$COLN TMP-BRICK ; ( y x -- addr )
      _         BRICK.TMP ADR-BRICK EXIT


;----------------------------------------------------------------------------+
;                                                                            |
;                                                                            |
;                                                                            |
;----------------------------------------------------------------------------+



; ----
; 頥  ࠧ 䨣 [0..6]
;
$COLN BRICKS ; ( n -- addr )
      _         CASE
      _           0 OF BRICK1 ENDOF
      _           1 OF BRICK2 ENDOF
      _           2 OF BRICK3 ENDOF
      _           3 OF BRICK4 ENDOF
      _           4 OF BRICK5 ENDOF
      _           5 OF BRICK6 ENDOF
      _           6 OF BRICK7 ENDOF
      _         ENDCASE
      _         EXIT

; ----
;  ࠧ 䨣  ⥪ 䨣 (BRICK.DATA)
;
$COLN SET-BRICK ; ( addr-brick -- )
      _         BRICK.DATA 64 CMOVE EXIT

; ----
; ᮧ  砩 䨣
;
$COLN NEW-BRICK ; ( -- )
      _         1 GAME.PIECES +!
      _         BRICK.NEXT @ BRICKS SET-BRICK
      _         7 RANDOM DUP BRICK.NEXT !
      _         BRICK.SCORE SWAP CELLS + C@ GAME.SCORE +! EXIT


; ---
; 饭 ⥪饩 䨣 /ࠢ
;
$COLN ROTATE-LEFT
      _         4 0 DO
      _             4 0 DO
      _                 J I CUR-BRICK 2W@
      _                 3 I - J TMP-BRICK 2W!
      _             LOOP
      _         LOOP
      _         BRICK.TMP SET-BRICK
      _         EXIT


$COLN ROTATE-RIGHT
      _          4 0 DO
      _              4 0 DO
      _                  J I CUR-BRICK 2W@
      _                  I 3 J - TMP-BRICK 2W!
      _              LOOP
      _          LOOP
      _          BRICK.TMP SET-BRICK
      _          EXIT


; ----
; ᮢ ⥪饩 䨣  ⠪
;
$COLN PUT-BRICK ; ( -- )
      _         BRICK.Y @ BRICK.X @
      _         4 0 DO
      _             4 0 DO
      _                 J I CUR-BRICK 2C@
      _                 EMPTY-CELL D<>
      _                 IF
      _                     OVER J + OVER I + PIT-ADR
      _                     J I CUR-BRICK 2W@ ROT 2W!
      _                 THEN
      _             LOOP
      _         LOOP
      _         2DROP EXIT


; ----
; 㤠 䨣  ⠪
;
$COLN REMOVE-BRICK ; ( y x -- )
      _         4 0 DO
      _             4 0 DO
      _                 J I CUR-BRICK 2C@
      _                 EMPTY-CELL D<>
      _                 IF
      _                     OVER J + OVER I + PIT-ADR
      _                     PIT.BACKGR PIT.BACKGR ROT 2W!
      _                 THEN
      _             LOOP
      _         LOOP
      _         2DROP EXIT

; ----
;    ࠧ饭 䨣    ⠪
;  室: true - , false - 
;
$COLN TEST-BRICK ; ( y x -- flag )
      _         4 0 DO
      _             4 0 DO
      _                 J I CUR-BRICK 2C@ EMPTY-CELL D<>
      _                 IF
      _                     OVER J + OVER I + OVER DUP 0<
      _                     SWAP PIT.HEIGHT >= OR
      _                     OVER DUP 0< SWAP PIT.WIDTH >= OR
      _                     2SWAP PIT-ADR 2C@ EMPTY-CELL D<> OR OR
      _                     IF
      _                         UNLOOP UNLOOP 2DROP
      _                         FALSE EXIT
      _                     THEN
      _                 THEN
      _             LOOP
      _         LOOP
      _         2DROP
      _         TRUE EXIT


; ----
; ६饭 䨣   ࠢ, ᫨ 
;
$COLN MOVE-BRICK ; ( incrY incrX -- flag )
      _         BRICK.Y @ BRICK.X @ REMOVE-BRICK
      _         SWAP BRICK.Y @ + SWAP BRICK.X @ +
      _         2DUP TEST-BRICK
      _         IF
      _             BRICK.X ! BRICK.Y !
      _             PUT-BRICK
      _             TRUE
      _             PIT-DRAW
      _         ELSE
      _             2DROP
      _             PUT-BRICK
      _             FALSE
      _         THEN
      _         EXIT

; ----
; 饭 䨣
;
$COLN ROTATE-BRICK  ; ( -- )
      _         BRICK.Y @ BRICK.X @ REMOVE-BRICK
      _         ROTATE-LEFT
      _         BRICK.Y @ BRICK.X @ TEST-BRICK
      _         IF
      _             DROP
      _             PUT-BRICK
      _             PIT-DRAW                         ; ७ᨬ ⠪  ࠭
      _         ELSE
      _             ROTATE-RIGHT
      _             PUT-BRICK
      _         THEN
      _         EXIT



; ----
; ⠢ 䨣, ᫨ 
;
$COLN INSERT-BRICK ; ( y x -- flag )
      _         2DUP
      _         TEST-BRICK
      _         IF
      _             BRICK.X ! BRICK.Y !
      _             PUT-BRICK
      _             TRUE
      _         ELSE
      _             2DROP
      _             FALSE
      _         THEN
      _         PIT-DRAW                    ; ७ᨬ ⠪  ࠭
      _         EXIT

; ----
; ஥ ६饭 䨣 
;
$COLN DROP-BRICK ; ( -- )
      _         BEGIN
      _             1 0 MOVE-BRICK V-SYNC 0=
      _         UNTIL
      _         EXIT


; ----
; ᬥ饭   ⠪
;
$COLN MOVE-LINE  ; ( from to -- )
      _         OVER 0 PIT-ADR
      _         SWAP 0 PIT-ADR
      _         PIT.CWIDTH 2*
      _         CMOVE
      _         PIT-CLRLIN
      _         EXIT



; ----
; ஢ઠ  ⠪  
;
$COLN TEST-LINE ; ( line-no -- flag )
      _         TRUE
      _         PIT.WIDTH 0 DO
      _             OVER I PIT-ADR 2C@ EMPTY-CELL D=
      _             IF
      _                 DROP FALSE LEAVE
      _             THEN
      _         LOOP
      _         NIP EXIT

; ----
; ஢ઠ ⠪  㤠  
;
$COLN PIT-CHECKFULL  ; ( -- )
      _         PIT.HEIGHT PIT.HEIGHT
      _         BEGIN
      _             SWAP
      _             BEGIN
      _                 1- DUP 0<
      _                 IF
      _                     2DROP
      _                     PIT-DRAW
      _                     EXIT                   ; ॡࠫ  
      _                 THEN
      _                 DUP TEST-LINE
      _             WHILE
      _                 1 GAME.LEVELS +!
      _                 10 GAME.SCORE +!
      _             REPEAT
      _             SWAP 1- 2DUP = NOT
      _             IF
      _                 2DUP MOVE-LINE             ; ᬥ頥 
      _             THEN
      _         AGAIN


; ----
; ᨬ  孨 ॣ
;
$COLN UPPER-CHAR ; ( char -- char )
      _         DUP 'a' '{' WITHIN
      _         IF
      _             ' ' -
      _         THEN EXIT


; ----
;   쭥訥 ⢨
;
$COLN GET-INPUT ; ( str -- flag )
      _         STATUS-STR KEY STATUS-CLR UPPER-CHAR 'Y' >< EXIT


; ----
; ॠ   
;
$COLN ON-KEY ; ( key -- flag )
      _         UPPER-CHAR
      _         CASE
      _             KEY.LEFT  OF  0 -1 MOVE-BRICK DROP  ENDOF
      _             KEY.RIGHT OF  0  1 MOVE-BRICK DROP  ENDOF
      _             KEY.ROT   OF  ROTATE-BRICK ENDOF
      _             KEY.DROP  OF  DROP-BRICK  ENDOF
      _             KEY.PAUSE OF  sPause STATUS-STR KEY STATUS-CLR DROP ENDOF
      _             KEY.NEW   OF  sNew GET-INPUT EXIT ENDOF
      _             KEY.QUIT  OF  sQuit GET-INPUT DUP GAME.CONTINUE !  EXIT ENDOF
      _         ENDCASE  TRUE EXIT


; ----
;  ᪮ ,  ᨬ  ⥪饣 ஢
;
$COLN CALCK-SPEED ; ( -- )
      _         GAME.LEVELS @ DUP  50 <
      _         IF
      _             100 OVER -
      _         ELSE
      _             DUP 100 <
      _             IF
      _                 62 OVER 2 SHR -
      _             ELSE
      _                 DUP 500 <
      _                 IF
      _                     31 OVER 4 SHR -
      _                 ELSE
      _                     0
      _                 THEN
      _             THEN
      _         THEN
      _         GAME.SPEED ! DROP EXIT


; ----
;  
;
$COLN PLAY-GAME ; ( -- )
      _         BEGIN
      _             NEW-BRICK
      _             -1 3 INSERT-BRICK
      _             NEXT-DRAW
      _         WHILE
      _             BEGIN
      _                 4 0 DO
      _                     HELP.X HELP.Y GOTO-XY
      _                     KEY?
      _                     IF
      _                         BEGIN
      _                             KEY KEY?
      _                         WHILE
      _                             DROP
      _                         REPEAT
      _                         ON-KEY 0=         ; ࠡ뢠  
      _                         IF
      _                             UNLOOP EXIT   ; 뢠 
      _                         THEN
      _                     THEN
      _                     GAME.SPEED @ DELAY
      _                 LOOP
                        ; ६頥 䨣 
      _                 1 0 MOVE-BRICK  0=
      _             UNTIL
                    ; 䨣 ⨣ "", ஢塞  㤠塞 . 
      _             PIT-CHECKFULL
      _             SHOW-SCORES
      _             CALCK-SPEED
      _         REPEAT
                ; 訢  ,  室
      _         sNew GET-INPUT NOT GAME.CONTINUE !
      _         EXIT



$COLN RUN-TETRIS
      _         INIT-GAME
      _         INIT-BRICKS
      _         sAnyKey STATUS-STR KEY STATUS-CLR DROP
      _         BEGIN
      _             PLAY-GAME
      _             GAME.CONTINUE @
      _         WHILE
      _             INIT-GAME
      _         REPEAT
      _         0 23 GOTO-XY CR EXIT

