;  -      (DS=ES=SS)

IMMEDIATE       = 1             ; 䫠 ᫮  ᯮ

;+-------------------------------------------------------------------------+
;|                                                   |
;+-------------------------------------------------------------------------+

include "stack.inc"             ; ⥪,  ॠ樨 ᫮ 室  横

macro $SWAP new, old: rest
    ??ch equ &old&
    ??pos InStr ??NAME, ??ch
    :while
    if ??pos
      ??prev SubStr ??NAME, 1, ??pos-1
      ??next SubStr ??NAME, ??pos+1
      ??NAME CatStr ??prev, <new>, ??next
      ??pos  InStr  ??NAME, ??ch
      goto while
    endif
endm

macro $PRENAME name: rest
    ??NAME   equ &name&
    $SWAP    less, <<
    $SWAP    more, >
    $SWAP    save, !
;;    $SWAP    squote, <">
endm

macro $POSTNAME name
    ??NAME   equ &name&
    $SWAP    plus, +
    $SWAP    minus, -
    $SWAP    mul, *
    $SWAP    eq, =
    $SWAP    div, /
    $SWAP    dot, .
    $SWAP    tld, ~
endm



;+-------------------------------------------------------------------------+
;|            ࠡ稩   ᯮ ᥫ  ᨬ             |
;+-------------------------------------------------------------------------+
macro $ISNUM n
    ??ISNUM = 0
    ??NUM equ &n&
    @len sizestr ??NUM
    ;; ஢塞  ᨬ
    @cfirst SubStr ??NUM, 1, 1
    @IsFirst InStr <''>, @cfirst
    if (@IsFirst ne 0)
        ;;  ᨬ, ࠡ뢠  ᫮
        ??ISNUM = 1
        exitm
    endif
    ;; ஢塞  ᨬ  稥  ᫠
    @IsFirst InStr <-+>, @cfirst
    if (@IsFirst ne 0)
        ;;    ᫠, 㡨ࠥ 
        ??NUM SubStr ??NUM, 2, @len-1
        @cfirst SubStr ??NUM, 1, 1
        @len sizestr ??NUM
    endif
    if (@len eq 0)
        ;;   ᫮
        exitm
    endif
    ;; ஢塞 ᭮ ᫠  ᫥ ᨬ
    @numstr CatStr <0123456789>
    @clast SubStr ??NUM, @len, 1
    @IsLast InStr <bBhH>, @clast
    if (@IsLast ne 0)
        ;;  ᭮ ᫠, 㡨ࠥ 
        if (@IsLast gt 2)
            ;;  ⭠筮 ᫮
            @numstr CatStr @numstr,<ABCDEFabcdef>
        else
            ;;  筮 ᫮, ⨬ ⮫쪮 0  1
            @numstr CatStr <01>
        endif
        ??NUM SubStr ??NUM, 1, @len-1
        @len sizestr ??NUM
    endif
    ;;  ᨬ, ᫥ ,   
    @IsFirst InStr <0123456789>, @cfirst
    if (@len eq 0) or (@IsFirst eq 0)
        exitm
    endif
    ;; ᪠㥬 ᫮,   ᨬ   ᭮
    rept @len
        @nchr SubStr ??NUM, 1, 1
        ??NUM SubStr ??NUM, 2, @len
        @isDigit InStr @numstr, @nchr
        if (@isDigit eq 0)
            exitm
        endif
    endm
    if (@isDigit ne 0)
        ??ISNUM = 1
    endif
endm


;+-------------------------------------------------------------------------+
;|                                           |
;+-------------------------------------------------------------------------+

macro $LABEL name
    _&name&:
endm

macro $COMPILENAME name
    ifdef _&name&_F
      _&name                  ;;  믮塞 ᫮
    else
      dw      _&name          ;;  㥬 ᫮  
    endif
endm

macro $COMPILE name
    $ISNUM <&name>
    if ??ISNUM
        dw      _LIT
        dw      &name
    else
      $POSTNAME name
%     $COMPILENAME ??NAME
    endif
endm


;  ᫮
macro $parsewords name: vararg
    irp @i, <name>
        $COMPILE @i
    endm
endm

;  ᯨ᮪ ᫮   ࠬ஢ ᫮
macro _ listcmd: rest
    $PRENAME listcmd
%    $parsewords ??NAME
endm

; । ᫮  . 
macro $CODE cname: rest
    $PRENAME cname
%   $POSTNAME ??NAME
;        align 4
    $LABEL <%??NAME>
endm

; । ᫮   
macro $COLN cname: rest
    $CODE cname
        call    _DOLST
endm

; 室  ᫥饬 ᫮ (⮫쪮  ᫮ । १ $CODE)
macro $NEXT
        lodsw
        jmp     ax
endm


;    
; b     - 
; x     - ᫮
; a     - 
; n     - ᫮  
; u     - ᫮  
; d     -  ᫮  
; ud    -  ᫮  
; s     - 楯窠 ᨬ

;+-------------------------------------------------------------------------+
;|                                                         |
;+-------------------------------------------------------------------------+

; 襭 樨 ᫮  ⮬  (蠥 । $COLN)
$CODE EXIT
        mov     si, [bp]
        add     bp, 2
        $NEXT

; ᫮ 室
$COLN BRANCH
      _         R> @ >R EXIT

; ᫮ 室
$CODE ?BRANCH
        pop     ax            ; ᭨  ⥪ ᫮ (TRUE or FALSE)
        mov     cx, [si]
        xor     bx, bx
        lea     dx, [si+2]
        sub     ax, 1
        sbb     bx, 0         ; if (ax==0) bx=-1 else bx=0
        and     cx, bx        ; if (ax==0) cx=[si] else cx=0
        not     bx            ;
        and     dx, bx        ; if (ax==0) dx=0 else dx=(si+2)
        or      dx, cx
        mov     si, dx        ; if (ax==0) si=[si] (jmp) else si+=2 (skip)
        $NEXT


; ७ ᫥饥  ᮡ ᫮  䬥᪨ ⥪
$CODE LIT
        lodsw
        push    ax
        $NEXT

;$COLN LIT
;      _         R@ @ R> CELL + >R EXIT


; 믮 ᫮   addr, । १ ४⨢ $COLON
$CODE DOLST   ; ( addr -- )
        xchg    bp, sp
        push    si
        xchg    bp, sp
        pop     si
        $NEXT


;+-------------------------------------------------------------------------+
;|                                                        |
;+-------------------------------------------------------------------------+

; ६, ᨢ,  樠஢ ६
macro VARIABLE name: req, len, var
    $CODE <&name>
    @name CatStr <$$_>,??NAME
%        push offset @name
     $NEXT
  ifnb <var>
    align 2
    ifnb <len>
%        @name dw len dup(var)
    else
%        @name dw var
    endif
  else
    udataseg
    align 2
    ifnb <len>
%        @name dw len dup(?)
    else
%        @name dw ?
    endif
    codeseg
  endif
endm

; ⠭
macro CONSTANT name, imm:req
    $CODE <&name>
        push    &imm
        $NEXT
endm

; ᪠-ப
macro STRING name, imm:rest
  local @endstr
    $CODE <&name>
    @name CatStr <$$_>,??NAME
%        push offset @name
        $NEXT
        align 2
%    label @name byte
        db @endstr - @name - 1          ;;   ப
        db &imm&
     label @endstr byte
endm


;+-------------------------------------------------------------------------+
;|                                                                   |
;+-------------------------------------------------------------------------+



;+-------------------------------------------------------------------------+
;|                                                           |
;+-------------------------------------------------------------------------+
; IF .. ELSE .. THEN
  _IF_F         = IMMEDIATE
  _THEN_F       = IMMEDIATE
  _ELSE_F       = IMMEDIATE

macro _IF                       ; ( bool -- )
        $PUSH   <??LABEL>
        dw      _?BRANCH
%       dw      ??LABEL
endm

macro _THEN
        $POP    <??LABEL>
%  ??LABEL:
endm

macro _ELSE
        $POP    <??LABEL>
        $PUSH   <??NEWLAB>
        dw      _BRANCH
%       dw      ??NEWLAB
%  ??LABEL:
endm

; CASE OF .. ENDOF, ... ENDCASE
  _CASE_F       = IMMEDIATE
  _OF_F         = IMMEDIATE
  _ENDOF_F      = IMMEDIATE
  _ENDCASE_F    = IMMEDIATE

macro _CASE                     ; ( n -- )
        $PUSH                   ;; ⪠ 室  CASE
endm

macro _OF                       ; ( n i -- n )
        $PUSH   <??LABEL>       ;; next OF
        dw      _OF_
%       dw      ??LABEL         ;; next OF
endm

macro _ENDOF
        $POP    <??LABEL>
        $TOP    <??CASEEND>
        dw      _BRANCH
%       dw      ??CASEEND       ;; jmp end
% ??LABEL:                      ;; next OF
endm

macro _ENDCASE
        _       DROP
        $POP    <??LABEL>
% ??LABEL:
endm

$COLN OF_
      _         OVER = IF DROP R> CELL+ ELSE R> @ THEN >R EXIT



;+-------------------------------------------------------------------------+
;|                                                                    |
;+-------------------------------------------------------------------------+
; BEGIN .. UNTIL
; BEGIN .. AGAIN
; BEGIN .. WHILE .. REPEAT

  _BEGIN_F      = IMMEDIATE
  _UNTIL_F      = IMMEDIATE
  _AGAIN_F      = IMMEDIATE
  _WHILE_F      = IMMEDIATE
  _REPEAT_F     = IMMEDIATE


macro _BEGIN                    ; ( -- )
        $PUSH   <??LABEL>       ; ⪠ 砫 横
% ??LABEL:
endm

macro _UNTIL ; (f -- )
        $POP    <??LABEL>
        dw      _?BRANCH
%       dw      ??LABEL
endm

macro _AGAIN ; ( -- )
        $POP    <??LABEL>
        dw      _BRANCH
%       dw      ??LABEL
endm

macro _WHILE ; (f -- )
        $PUSH   <??LABEL>
        dw      _?BRANCH
%       dw      ??LABEL
endm

macro _REPEAT
        $POP    <??LABEL>
        $POP    <??LABBEG>
        dw      _BRANCH
%       dw      ??LABBEG
% ??LABEL:
endm



; DO .. LOOP
; DO .. +LOOP

  _DO_F         = IMMEDIATE
  _LOOP_F       = IMMEDIATE
  _PLUSLOOP_F   = IMMEDIATE

macro _DO       ; ( n n -- )
        $PUSH   <??LABEL>
        dw      _DO_
%       dw      ??LABEL         ;; ⪠   横
        $PUSH   <??LABEL>       ;; ⪠  LOOP  +LOOP
% ??LABEL:
endm

macro _LOOP
        $POP    <??LABEL>       ;; ⪠ 砫 横
        dw      _LOOP_
%       dw      ??LABEL
        $POP    <??LABEL>
% ??LABEL:
endm

macro _plusLOOP
        $POP    <??LABEL>       ;; ⪠ 砫 横
        dw      _plusLOOP_
%       dw      ??LABEL
        $POP    <??LABEL>
% ??LABEL:
endm


$COLN DO_ ; (i2 i1 -- ) i1 - 砫쭮 祭, i2 - ࠭筮 祭
      _         R> DUP @ >R ROT >R SWAP >R CELL+ >R EXIT


;; ࠡ稩 ਠ loop  
;$COLN LOOP_   ;
;      _         R> R> R@ - 1+ DUP 0= IF DROP R> R> 2DROP CELL+ ELSE R@ + >R @ THEN >R EXIT

; ਠ loop  ᥬ
$CODE LOOP_
        mov     bx, 1
        jmp     $$do_loop
$CODE +LOOP_
        pop     bx              ; bx - increment
    $$do_loop:
        add     [bp], bx
        mov     ax, [bp]
        sub     ax, [bp+2]
        xor     ax, bx
        js      @@endlp
        ; end of loop
        add     bp, 6
        inc     si
        inc     si
        $NEXT
    @@endlp:
        mov     si, [si]
        $NEXT


$COLN I       ; ( -- n )                ⥪ 稪 ⥪饣 横
      _         R> R@ SWAP >R EXIT

$CODE J       ; ( -- n )                ⥪ 稪 横 ।. ஢
        mov     ax, [bp+6]
        push    ax
        $NEXT


$COLN LEAVE  ; (R: ret-cycle i2-࠭筮 i1-砫쭮 ret)
      _         R> DROP R> DROP R> DROP EXIT

$COLN UNLOOP ; (R: ret-cycle i2-࠭筮 i1-砫쭮 ret)
      _         R> R> DROP R> DROP R> DROP >R EXIT




;+-------------------------------------------------------------------------+
;|                                                            |
;+-------------------------------------------------------------------------+
$CODE RP@     ; ( -- a )                . ⥪  ⥪ ⮢
        push    bp
        $NEXT

$CODE RP!     ; ( a -- )                祭 誨 ⥪ ⮢
        pop     bp
        $NEXT

$CODE >R      ; ( x -- )(R: -- x )    ७ x  . ⥪  ⥪ ⮢
        pop     ax
        xchg    bp, sp
        push    ax
        xchg    bp, sp
        $NEXT

$CODE R>      ; ( -- x )(R: x -- )    ७ x  ⥪ ⮢  . ⥪
        xchg    bp, sp
        pop     ax
        xchg    bp, sp
        push    ax
        $NEXT

$CODE R@      ; ( -- x )(R: x -- x )   x  ⥪ ⮢  . ⥪
        mov     ax, [bp]
        push    ax
        $NEXT


;+-------------------------------------------------------------------------+
;|                                                       |
;+-------------------------------------------------------------------------+

$CODE SP@     ; ( -- a )                . ⥪
        mov     ax, sp
        push    ax
        $NEXT

$CODE SP!     ; ( a -- )                 . ⥪
        pop     ax                    ; 'pop sp'    ਧ
        mov     sp, ax
        $NEXT

$COLN DUP     ; ( x -- x x )          㡫஢ 誨 ⥪
      _         >R R@ R> EXIT

$COLN ?DUP    ; ( x -- x | x x )      த㡫஢ x, ᫨ x <> 0
      _         DUP IF DUP THEN EXIT

$COLN DROP    ; ( x -- )               孥  ⥪
      _         SP@ CELL+ SP! EXIT

$COLN ROT     ; ( x1 x2 x3--x2 x3 x1) 横᪠ ⠭  孨 ⮢
      _         >R SWAP R> SWAP EXIT

$COLN SWAP    ; ( x1 x2 -- x2 x1 )    ⠭  孨 ⮢ ⥪
      _         OVER >R >R DROP R> R> EXIT

$COLN OVER    ; ( x1 x2 -- x1 x2 x1 ) 㡫஢ ண ᢥ  ⥪
      _         SP@ CELL+ @ EXIT

$COLN 2DUP    ; ( x x -- x x x x )    த㡫஢  孨 
      _         OVER OVER EXIT

$COLN 2DROP   ; ( x1 x2 -- )           孥  
      _         DROP DROP EXIT

$COLN 2OVER   ; ( xd1 xd2 -- xd1 xd2 xd1)
      _         SP@ CELL+ CELL+ 2@ EXIT

$CODE 2SWAP   ; ( xd1 xd2 -- xd2 xd1 )
        pop     ax dx cx bx
        push    dx ax bx cx
        $NEXT

$COLN PICK    ; ( n -- an an-1 .. an)    n-  ⥪ (稭  )
      _         1+ CELLS SP@ + @ EXIT

$COLN NIP     ; ( x1 x2 -- x2 )           設 ⥪
      _         >R DROP R> EXIT

$CODE ROLL    ; (a {n ᫮} cnt -- {n ᫮} a)
        pop     bx      ; bx - count
        or      bx, bx
        jz      @@roll_exit
        mov     di, sp
        shl     bx, 1
        mov     dx, [di+bx]
    @@roll_loop:
        sub     bx, 2
        mov     ax, [di+bx]
        mov     [di+bx+2], ax
        jnz     @@roll_loop
        mov     [di], dx
    @@roll_exit:
        $NEXT

;+-------------------------------------------------------------------------+
;                                                         |
;+-------------------------------------------------------------------------+

$CODE @       ; ( addr -- x )         ⥭ ᫮ x   addr
        pop     bx
        push    [word bx]
        $NEXT

$CODE C@      ; ( addr -- b )         ⥭  b  c addr (  ᫮)
        pop     bx
        xor     ax, ax
        mov     al, [bx]
        push    ax
        $NEXT

$CODE !       ; ( x addr -- )          ᫮ x   addr
        pop     bx
        pop     [word bx]
        $NEXT

$CODE C!      ; ( b addr -- )           b   addr
        pop     bx
        pop     ax
        mov     [bx], al
        $NEXT

$COLN 2@      ; ( addr -- xd )        ⥭  ᫠   addr
      _         DUP CELL+ @ SWAP @ EXIT

$COLN 2!      ; ( xd addr -- )          ᫠   addr
      _         SWAP OVER ! CELL+ ! EXIT

$CODE @L      ; ( segm addr -- x )    ⥭ ᫮ x   segm:addr
        pop     bx
        pop     es
        mov     ax, [es:bx]
        push    ax
        $NEXT

$CODE C@L     ; ( segm addr -- b )    ⥭  b  c segm:addr (  ᫮)
        pop     bx
        pop     es
        xor     ax, ax
        mov     al, [es:bx]
        push    ax
        $NEXT

$CODE !L      ; ( x segm addr -- )     ᫮ x   segm:addr
        pop     di
        pop     es
        pop     ax
        stosw
        $NEXT

$CODE C!L     ; ( b segm addr -- )      b   segm:addr
        pop     di
        pop     es
        pop     ax
        stosb
        $NEXT


;+-------------------------------------------------------------------------+
;|                                                        |
;+-------------------------------------------------------------------------+
;   ᥫ
$COLN =       ; ( x1 x2 -- f )        if (x1 == x2) f=TRUE else f=FALSE
      _         XOR IF FALSE ELSE TRUE THEN EXIT

$COLN ><      ; ( x1 x2 -- f )        if (x1 != x2) f=TRUE else f=FALSE
      _         = NOT EXIT

$COLN 0=      ; ( x -- f )            if (x = 0) f=TRUE else f=FALSE
      _         NULL = EXIT

;  ᥫ  
$COLN 0<      ; ( n -- f )            if (n < 0) f=TRUE else f=FALSE
      _         15 SHR 1- NOT EXIT

$COLN >0      ; ( n1 n2 -- f )        if (n > 0) f=TRUE else f=FALSE
      _         NEG 0< EXIT

$COLN <<      ; ( n1 n2 -- f )        if (n1 <  n2) f=TRUE else f=FALSE
      _         2DUP XOR 0< IF DROP ELSE - THEN 0< EXIT

$COLN >       ; ( n1 n2 -- f )        if (n1 >  n2) f=TRUE else f=FALSE
      _         2DUP = ROT ROT < OR NOT EXIT

$COLN <<=
      _         > NOT EXIT
$COLN >=
      _         << NOT EXIT


;   ᥫ
$COLN U<      ; ( u1 u2 -- f )        if (u1 <  u2) f=TRUE else f=FALSE
      _         2DUP XOR 0< IF SWAP DROP ELSE - THEN 0< EXIT

; ᫠  筮
$COLN D0=     ; ( d -- f )            if ( d == 0 ) f=TRUE else f=FALSE
      _         0= SWAP 0= AND EXIT

$COLN D=      ; ( d1 d2 -- f )
      _         D- D0= EXIT

$COLN D<      ; ( d1 d2 -- f)         if (d1 < d2) f=TRUE else f=FALSE
      _         D- DROP 0< EXIT

$COLN D>      ; ( d1 d2 -- f)         if (d1 > d2) f=TRUE else f=FALSE
      _         2SWAP D< EXIT


;   ஢७
$COLN D0<     ; ( d -- f )            if (d < 0) f = TRUE else f = FALSE
      _         DROP 0< EXIT
$COLN D>0     ; ( d -- f )            if (d > 0) f = TRUE else f = FALSE
      _         2SWAP D0< EXIT


;+-------------------------------------------------------------------------+
;|                                                   |
;+-------------------------------------------------------------------------+
; ᫠  筮 ࠭  :
; d - hi      lo
;     ^       ^
;     [SP+2]  |
;             [SP]
CONSTANT CELL, 2
CONSTANT NULL, 0

$COLN TRUE    ; ( -- true )
      _         NULL NOT EXIT

$COLN FALSE   ; ( -- false )
      _         NULL EXIT

$COLN ABS     ; ( n -- n )            abs(n)
      _         DUP 0< IF NEG THEN EXIT

$COLN NEG     ; ( n -- -n )           n = -n
      _         NOT 1+ EXIT

$COLN MAX     ; ( n1 n2 -- n )        n = max(n1, n2)
      _         2DUP < IF SWAP THEN DROP EXIT

$COLN MIN     ; ( n1 n2 -- n )        n = min(n1, n2)
      _         2DUP SWAP < IF SWAP THEN DROP EXIT

$COLN 1+      ; ( x -- x )            x += 1
      _         1 + EXIT

$COLN 1-      ; ( x -- x )            x -= 1
      _         1 - EXIT

$CODE +       ; ( x1 x2 -- x )        x = x1 + x2
        pop     ax
        pop     bx
        add     ax, bx
        push    ax
        $NEXT
;        _       UM+ NIP EXIT

$COLN +!      ; ( n addr -- ) ਡ n     addr
      _         DUP @ ROT + SWAP ! EXIT

$COLN 2/       ; ( n -- n ) 䬥᪨ ᤢ ࠢ  1
      _         DUP 1 SHR SWAP 8000h AND OR EXIT

$COLN 2*      ; ( n -- n ) ᤢ   1
      _         1 SHL EXIT

$COLN -       ; ( x1 x2 -- x )        x = x1 - x2
      _         NEG + EXIT

$COLN CELL+   ; ( addr -- addr )      addr += CELL_SIZE
      _         CELL + EXIT

$COLN CELL-   ; ( addr -- addr )      addr -= CELL_SIZE
      _         CELL - EXIT

$COLN CELLS   ; ( n -- n )            ; n = n * CELL_SIZE
      _         CELL * EXIT

$COLN WITHIN  ; ( u ul uh -- f )      if (ul<=u<uh) f=TRUE else f=FALSE
      _         OVER - >R - R> U< EXIT

;   ᫮
$COLN *       ; ( n1 n2 -- n )        n = n1 * n2
      _         M* NIP EXIT

$COLN /       ; ( n1 n2 -- n )        n = n1 / n2
      _         /MOD NIP EXIT

$COLN MOD     ; ( n1 n2 -- n )        n = n1 % n2
      _         /MOD DROP EXIT

$COLN /MOD    ; ( n1 n2 -- r q )      r= n1 % n2;  q = n1 / n2
      _         OVER 0< ROT ROT M/MOD EXIT  ; 0<   0  -1

$COLN */      ; ( n1 n2 n3 -- n )     n = (n1 * n2) / n3
      _         */MOD NIP EXIT

$COLN */MOD   ; ( n1 n2 n3 -- r q )   q = (n1 * n2) / n3; r = (n1 * n2) % n3
      _         >R M* R> M/MOD EXIT

; 䬥⨪   筮
$CODE UM*     ; ( u1 u2 -- ud )       ud = u1 * u2
        pop     cx ax
        mul     cx
        push    dx ax
        $NEXT

$CODE M*      ; ( n1 n2 -- d )        d = n1 * n2
        pop     cx ax
        imul    cx
        push    dx ax
        $NEXT

$CODE UM/MOD  ; ( ud u -- r q)        r = ud % u; q = ud / u
        pop     cx ax dx
        div     cx
        push    dx ax
        $NEXT

$CODE M/MOD   ; ( d n -- r q )        r = d % n; q = d / n
        pop     cx ax dx
        idiv    cx
        push    dx ax
        $NEXT

$CODE UM+     ; ( u1 u2 -- ud )       ud = u1 + u2
        pop     ax
        pop     dx
        xor     cx, cx
        add     ax, dx
        rcl     cx, 1           ; 뢠  ७
        push    cx ax
        $NEXT

; ७ ᫮   ᫮
$COLN N>D     ; ( n -- d )            n->d
      _         DUP 0< SWAP EXIT

$COLN U>D     ; ( u -- ud )           u->ud
      _         NULL SWAP EXIT

; ᫮  筮
$CODE D+      ; ( ud1 ud2 -- ud )     ud = ud1 + ud2
        pop     ax dx
        mov     bx, sp
        add     [bx], ax
        adc     [bx+2], dx
        $NEXT

$COLN D-      ; ( d1 d2 -- d )        d = d1 - d2
      _         DNEG D+ EXIT

$COLN DNEG    ; ( d -- -d )
      _         NOT 1 UM+ >R SWAP NOT + R> EXIT

$COLN DABS    ; ( d -- ud )
      _         OVER 0< IF DNEG THEN EXIT

;+-------------------------------------------------------------------------+
;|                                                       |
;+-------------------------------------------------------------------------+

$CODE AND     ; ( x1 x2 -- x )        x = x1 AND x2   ()
        pop     dx ax
        and     ax, dx
        push    ax
        $NEXT

$CODE OR      ; ( x1 x2 -- x )        x = x1 OR x2    ()
        pop     dx ax
        or      ax, dx
        push    ax
        $NEXT

$CODE XOR     ; ( x1 x2 -- x )        x = x1 XOR x2
        pop     dx ax
        xor     ax, dx
        push    ax
        $NEXT

$COLN NOT     ; ( x -- x )            x = NOT x       (栭)
      _         -1 XOR EXIT

$CODE SHL     ; ( x1 u -- x )         x = x SHL u
        pop     cx ax
        shl     ax, cl
        push    ax
        $NEXT


$CODE SHR     ; ( x1 u -- x )         x = x SHR u
        pop     cx ax
        shr     ax, cl
        push    ax
        $NEXT


;+-------------------------------------------------------------------------+
;|                                                                     |
;+-------------------------------------------------------------------------+

$CODE KEY
        push    bp si
        xor     ax, ax
        int     16h
        or      al, al
        jz      done_key
        xor     ah, ah

    done_key:
        pop     si bp
        push    ax
        $NEXT

$CODE KEY?
        push    bp si
        mov     ah, 1
        int     16h
        mov     ax, 0
        jz      done_key                ; -> 祣  
        or      ax, -1
        jmp     done_key

;+-------------------------------------------------------------------------+
;|                                                           |
;+-------------------------------------------------------------------------+
VARIABLE PAD, 128                     ;   ଠ⭮ /뢮
VARIABLE HLD                          ; ⥪   PAD


$COLN DIGIT   ; ( u -- c )            ᫮  ᨬ
      _         9 OVER < 7 AND + '0' + EXIT

$COLN HOLD    ; ( c -- )               ᨬ   PAD
      _         HLD @ 1- DUP HLD ! C! EXIT

$COLN <<#     ; ( -- )                砫 ଠ⭮ ८ࠧ ᫠
      _         PAD 126 + HLD ! EXIT  ; ⠭ 㪠⥫    PAD

$COLN #>      ; ( d -- a n )           ଠ⭮ ८ࠧ
      _         2DROP HLD @ PAD 126 + OVER - EXIT

$COLN #       ; ( ud -- ud )            PAD  ᨬ  ᫠ ( BASE)
      _         OVER BASE @ U< NOT
      _         IF
      _             NULL ROT BASE @ UM/MOD
      _         ELSE
      _             SWAP NULL
      _         THEN
      _         >R SWAP BASE @ UM/MOD R> ROT DIGIT HOLD SWAP EXIT



$COLN #S      ; ( d -- 0 0 )           ८ࠧ ᫠  ப
      _         BEGIN # 2DUP D0= UNTIL EXIT

$COLN SIGN    ; ( n -- )                 PAD  ᫠, ᫨  ⥫쭮
      _         0< IF '-' HOLD THEN EXIT

;+-------------------------------------------------------------------------+
;|                          
;+-------------------------------------------------------------------------+
CONSTANT BL, ' '                      ; ᨬ ஡
VARIABLE ATR,,07h                     ; ਡ 뢮  (EMIT)


$CODE EMIT    ; (c -- )               뢮 ᨬ  ᯫ
        pop     ax
        push    ax
        cmp     al, 20h
        jb      @@emit_next
        mov     ax, 0920h
        mov     bx, [$$_ATR]
        xor     bh, bh
        mov     cx, 1
        int     10h
    @@emit_next:
        pop     ax
        mov     ah, 0Eh
        mov     bx, [$$_ATR]
        xor     bh, bh
        int     10h
        $NEXT

$COLN COUNT   ; ( addr -- addr+1 n)   ८ࠧ  ப      ⥪
      _         DUP 1+ SWAP C@ EXIT

$COLN TYPE    ; ( addr n -- )         뢮 ⥪     
      _         ?DUP IF NULL DO DUP @ EMIT 1+ LOOP THEN DROP EXIT


$COLN CR      ; ( -- )                ॢ ப
      _         13 10 EMIT EMIT EXIT

$COLN SPACE   ; ( -- )                뢮  ᯫ ᨬ ஡
      _ BL EMIT EXIT

$COLN SPACES  ; ( n -- )              뢮  ᯫ n ஡
      _         ?DUP IF NULL DO SPACE LOOP THEN EXIT


;+-------------------------------------------------------------------------+
;|                                                 |
;+-------------------------------------------------------------------------+

$COLN FILL    ; (addr n c -- )
      _         ROT ROT ?DUP
      _         IF
      _             NULL DO 2DUP C! 1+ LOOP
      _         THEN
      _         DROP DROP EXIT




$COLN BLANK   ; ( addr n -- )          ⮪   ஡
      _         BL FILL EXIT

$COLN ERASE   ; ( addr n -- )          ⮪  ﬨ
      _         NULL FILL EXIT

$CODE CMOVE   ; ( src dst n -- )       n   src  dst
        pop     cx
        pop     di
        pop     bx
        jcxz    @@cmove_exit
        push    si
        mov     si, bx
        push    ds
        pop     es
        cld
        shr     cx, 1
        rep     movsw
        adc     cx, 0
        rep     movsb
        pop     si
    @@cmove_exit:
        $NEXT

;$COLN CMOVE   ; (src dst count -- ) ਠ  
;      _         ?DUP
;      _         IF
;      _             ROT SWAP OVER + SWAP
;      _             DO
;      _                 I C@ OVER C! 1+
;      _             LOOP
;      _         ELSE
;      _             DROP
;      _         THEN
;      _         DROP EXIT


$COLN CMOVE>  ; (src dst count -- )    count   src  dst,  ⭮ 浪
      _         ?DUP
      _         IF
      _             1-  DUP >R + SWAP DUP R> +
      _             DO
      _                 I C@ OVER C! 1- -1
      _             +LOOP
      _         ELSE
      _             DROP
      _         THEN
      _         DROP EXIT





;+-------------------------------------------------------------------------+
;|                                                   |
;+-------------------------------------------------------------------------+
VARIABLE BASE ; ( -- addr )           ⥪饥 ᭮ ⥬ ᫥

$COLN HEX     ; ( -- )                ⠭ ᭮ ⥬ ᫥ ࠢ 16
      _         16 BASE ! EXIT

$COLN DECIMAL ; ( -- )                ⠭ ᭮ ⥬ ᫥ ࠢ 10
      _         10 BASE ! EXIT

$COLN OCTAL   ; ( -- )                ⠭ ᭮ ⥬ ᫥ ࠢ 8
      _         8 BASE ! EXIT

$COLN BINARY  ; ( -- )                ⠭ ᭮ ⥬ ᫥ ࠢ 2
      _         2 BASE ! EXIT

$COLN D.      ; ( d -- )              뢮   ᫠
      _         OVER SWAP DABS <# #S ROT SIGN #> TYPE SPACE EXIT

$COLN UD.     ; ( ud -- )             뢮   ᫠
      _         <# #S #> TYPE SPACE EXIT

$COLN D.R     ; ( d fn -- )           뢮   ᫠  ࠢ  ࠢ 
      _         2 PICK 2SWAP DABS <# #S ROT SIGN #> ROT OVER - DUP >0
      _         IF
      _             SPACES
      _         ELSE
      _             DROP
      _         THEN
      _         TYPE EXIT

$COLN UD.R    ; ( ud fn -- )          뢮   ᫠  ࠢ  ࠢ 
      _         ROT ROT <# #S #> ROT OVER - DUP >0
      _         IF
      _             SPACES
      _         ELSE
      _             DROP
      _         THEN
      _         TYPE EXIT

$COLN .       ; ( n -- )              뢮  ᫠
      _         N>D D. EXIT

$COLN U.      ; ( u -- )              뢮  ᫠
      _         U>D UD. EXIT

$COLN .R      ; ( n fn -- )           뢮  ᫠  ࠢ  ࠢ 
      _         SWAP N>D ROT D.R EXIT

$COLN U.R     ; ( u fn -- )           뢮  ᫠  ࠢ  ࠢ 
      _         SWAP U>D ROT UD.R EXIT





